#!/bin/sh

echo "Formatting.."
clang-format -i yaff2chr.c
clang-format -i chr2img.c

echo "Cleaning.."
rm -rf bin
mkdir bin

echo "Building.."
cc -Wall -Wextra -std=c89 -o bin/chr2bmp chr2img.c

cc -std=c89 -DDEBUG -Wall -Wno-unknown-pragmas -Wpedantic -Wshadow -Wuninitialized -Wextra -Werror=implicit-int -Werror=incompatible-pointer-types -Werror=int-conversion -Wvla -g -Og -fsanitize=address -fsanitize=undefined yaff2chr.c -o bin/yaff2chr

# uf1
# bin/yaff2chr etc/bbcmicro.yaff       bin/bbcmicro.uf1
# bin/yaff2chr etc/atari.yaff          bin/atari.uf1
# bin/yaff2chr etc/acorn8-regular.yaff bin/acorn8-regular.uf1
# bin/yaff2chr etc/acorn8-italic.yaff  bin/acorn8-italic.uf1

# uf2
bin/yaff2chr etc/msx816.yaff       bin/msx816.uf2
bin/yaff2chr etc/chicago12.yaff    bin/chicago12.uf2
bin/yaff2chr etc/losangeles12.yaff bin/losangeles12.uf2
bin/yaff2chr etc/terminal12.yaff   bin/terminal12.uf2
bin/yaff2chr etc/venice14.yaff     bin/venice14.uf2
bin/yaff2chr etc/diamond12.yaff    bin/diamond12.uf2
bin/yaff2chr etc/sapphire14.yaff   bin/sapphire14.uf2
bin/yaff2chr etc/palatino12.yaff   bin/palatino12.uf2
bin/yaff2chr etc/palatino14.yaff   bin/palatino14.uf2
bin/yaff2chr etc/newyork12.yaff    bin/newyork12.uf2
bin/yaff2chr etc/newyork14.yaff    bin/newyork14.uf2
bin/yaff2chr etc/helvetica12.yaff  bin/helvetica12.uf2
bin/yaff2chr etc/helvetica14.yaff  bin/helvetica14.uf2
bin/yaff2chr etc/times12.yaff      bin/times12.uf2
bin/yaff2chr etc/times15.yaff      bin/times15.uf2
bin/yaff2chr etc/geneva12.yaff     bin/geneva12.uf2
bin/yaff2chr etc/geneva14.yaff     bin/geneva14.uf2
bin/yaff2chr etc/courier12.yaff    bin/courier12.uf2
bin/yaff2chr etc/monaco12.yaff     bin/monaco12.uf2
bin/yaff2chr etc/sans10-regular.yaff bin/sans10-regular.uf2
bin/yaff2chr etc/sans10-bold.yaff    bin/sans10-bold.uf2

# uf3
# bin/yaff2chr etc/diamond20.yaff    bin/diamond20.uf3
# bin/yaff2chr etc/sapphire19.yaff   bin/sapphire19.uf3
# bin/yaff2chr etc/palatino24.yaff   bin/palatino24.uf3
# bin/yaff2chr etc/newyork24.yaff    bin/newyork24.uf3
# bin/yaff2chr etc/helvetica24.yaff  bin/helvetica24.uf3
# bin/yaff2chr etc/times24.yaff      bin/times24.uf3
# bin/yaff2chr etc/geneva24.yaff     bin/geneva24.uf3